Bug 1345887 - Review Request: golang-github-yosssi-ace - HTML template engine for Go
Summary: Review Request: golang-github-yosssi-ace - HTML template engine for Go
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Athos Ribeiro
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1430558
Blocks: 1426972
TreeView+ depends on / blocked
 
Reported: 2016-06-13 11:38 UTC by Olivier Lemasle
Modified: 2017-04-06 13:43 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-04-06 13:43:49 UTC
Type: ---
athoscribeiro: fedora-review+


Attachments (Terms of Use)

Description Olivier Lemasle 2016-06-13 11:38:20 UTC
Spec URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace.spec
SRPM URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace-0.0.4-1.fc23.src.rpm
Description: HTML template engine for Go
Fedora Account System Username: olem

Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=14471912

NB: I need a sponsor, as I'm not in maintainer group. I've already proposed an other package: https://bugzilla.redhat.com/show_bug.cgi?id=1344936

Comment 1 Athos Ribeiro 2017-03-04 18:37:15 UTC
Hello Olivier,

Did you introduce yourself in the devel mailing list yet? If so, provide a link for that here, please.

Also, it would help if you'd perform a few informal package reviews (you can provide the links here as well.

Comment 2 Olivier Lemasle 2017-03-05 23:32:32 UTC
Hi Athos,

I've just introduced myself on fedora-devel: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/message/HX6MYR6GMA6WH23VZ36IGRU7UR5OX53V/

I've also done an informal package review: https://bugzilla.redhat.com/show_bug.cgi?id=1332267 but I'll do more in the coming days.

Thanks!

Comment 3 Olivier Lemasle 2017-03-06 22:13:00 UTC
Hi Athos,

Following remark on https://fedoraproject.org/wiki/User:Athoscr/packaging_hugo, I opened an issue in the upstream project, asking for a new tag:

https://github.com/yosssi/ace/issues/75

Comment 4 Olivier Lemasle 2017-03-07 09:30:40 UTC
Following my request, a new tag has been pushed upstream; I've updated the package SPEC accordingly.

For this new package (0.0.5-1):
Spec URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace.spec
SRPM URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace-0.0.5-1.fc25.src.rpm

Koji build: https://koji.fedoraproject.org/koji/taskinfo?taskID=18244731

Comment 5 Athos Ribeiro 2017-03-07 16:25:51 UTC
Hi Olivier,

Thank you for getting upstream to release this new tag!

Your package should own the following directories:
  /usr/share/gocode/src/github.com/yosssi/ace/cmd,
  /usr/share/gocode/src/github.com/yosssi/ace/examples
    Note that the examples directory should be moved to %doc if not used for runtime

The examples directory seems to be just documentation, showing how the package could be used. If that's the case, it should go to %doc in the devel subpackage.

I noticed that under cmd, we have a main.go file: Are you also willing to provide a binary for this package? Do you have any comments on this?

When you change your spec file, remember to add a period on the Description section, as in the other review request.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[!]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: golang-github-yosssi-ace-devel-0.0.5-1.fc26.noarch.rpm
          golang-github-yosssi-ace-unit-test-devel-0.0.5-1.fc26.x86_64.rpm
          golang-github-yosssi-ace-0.0.5-1.fc26.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
2 packages and 0 specfiles checked; 0 errors, 0 warnings.



Requires
--------
golang-github-yosssi-ace-devel (rpmlib, GLIBC filtered):

golang-github-yosssi-ace-unit-test-devel (rpmlib, GLIBC filtered):
    golang-github-yosssi-ace-devel



Provides
--------
golang-github-yosssi-ace-devel:
    golang(github.com/yosssi/ace)
    golang-github-yosssi-ace-devel

golang-github-yosssi-ace-unit-test-devel:
    golang-github-yosssi-ace-unit-test-devel
    golang-github-yosssi-ace-unit-test-devel(x86-64)



Source checksums
----------------
https://github.com/yosssi/ace/archive/v0.0.5.tar.gz :
  CHECKSUM(SHA256) this package     : e19cc49b9738d8498926b97e5bff41f59a84416e389b6ecda9d9266d4ac81a2e
  CHECKSUM(SHA256) upstream package : e19cc49b9738d8498926b97e5bff41f59a84416e389b6ecda9d9266d4ac81a2e

Comment 6 Olivier Lemasle 2017-03-08 18:04:59 UTC
Hello Athos,

Thank you for your review.

- Regarding the directory ownership, I think I understand better now; I'll fix it.

- You're right, the examples directory contains code that is not part of the library (is not meant to be used in the code), so I'll add it to the %doc.

- Regarding the "cmd/ace" package and its main.go program, I'm not sure... It would be interesting to include it in the main package as a binary (not in the -devel subpackage), but do we need it? Furthermore, it depends on https://github.com/yosssi/gohtml (cf. [1]) which is currently not packaged in Fedora. What do you think is the best?

[1] https://github.com/yosssi/ace/blob/v0.0.5/cmd/ace/main.go#L11

Comment 7 Olivier Lemasle 2017-03-08 18:09:03 UTC
Also, following comments in your own package ticket [1], I'll remove the empty conditionals from the SPEC.

[1] https://bugzilla.redhat.com/show_bug.cgi?id=1426851

Comment 8 Athos Ribeiro 2017-03-08 18:40:32 UTC
(In reply to Olivier Lemasle from comment #6)

> - Regarding the directory ownership, I think I understand better now; I'll
> fix it.
> 

OK

> - You're right, the examples directory contains code that is not part of the
> library (is not meant to be used in the code), so I'll add it to the %doc.
> 

OK

> - Regarding the "cmd/ace" package and its main.go program, I'm not sure...
> It would be interesting to include it in the main package as a binary (not
> in the -devel subpackage), but do we need it? Furthermore, it depends on
> https://github.com/yosssi/gohtml (cf. [1]) which is currently not packaged
> in Fedora. What do you think is the best?

We do not need it at the moment, but someone else may need it (it would also be a good exercise for a new packager :). Since it would be a dependency for one of your packages, would you be willing to package it as well? If you are too busy with this one, let me know and I will package the dependency myself.

Comment 9 Olivier Lemasle 2017-03-08 22:53:20 UTC
Thanks, I will package golang-github-yosssi-gohtml myself and include ace binary program; that will be an exercise ;-)

Comment 10 Olivier Lemasle 2017-03-10 16:56:38 UTC
Here is the new package spec and SRPM:

Spec URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace.spec
SRPM URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace-0.0.5-2.fc25.src.rpm

Note that it depends on golang-github-yosssi-gohtml.

Rpmlint (installed packages)
----------------------------
golang-github-yosssi-ace.x86_64: W: ldd-failed /usr/bin/ace
golang-github-yosssi-ace.x86_64: E: statically-linked-binary /usr/bin/ace
golang-github-yosssi-ace.x86_64: W: no-manual-page-for-binary ace
4 packages and 0 specfiles checked; 1 errors, 2 warnings.

There's a Rpmlint error, as the binary is statically linked, but the Packaging Go Guidelines include this exception (https://fedoraproject.org/wiki/PackagingDrafts/Go#Packaging_Binaries)

Comment 11 Athos Ribeiro 2017-03-15 18:57:29 UTC
Hello Olivier,

The file

/usr/share/doc/golang-github-yosssi-ace-devel/examples/load_templates_from_binary_data/make_asset.sh

Is an executable file. It is pulling a /bin/sh dependency (Requires) to the -devel package.

Removing the executable permissions from it will probably stop it from pulling the dependency [1] (in case it does not, remove the shebang from the file as well).

Other than that, the package looks good!

[1] https://fedoraproject.org/wiki/Packaging:Guidelines#Documentation

Comment 12 Olivier Lemasle 2017-03-16 21:22:35 UTC
Hello Athos,

Thanks, I wasn't aware it was the cause of this unnecessary dependency. I've fixed the issue; please find the new spec:

Spec URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace.spec
SRPM URL: https://olem.fedorapeople.org/reviews/golang-github-yosssi-ace-0.0.5-3.fc25.src.rpm

Comment 13 Athos Ribeiro 2017-03-17 20:29:11 UTC
Package looks good now! Approved.

Comment 14 Olivier Lemasle 2017-03-17 23:28:26 UTC
Thanks for the review, Athos!

Comment 15 Gwyn Ciesla 2017-03-20 12:54:55 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-yosssi-ace

Comment 16 Fedora Update System 2017-04-01 18:07:59 UTC
golang-github-yosssi-ace-0.0.5-3.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0c91eb16d1

Comment 17 Fedora Update System 2017-04-03 03:52:37 UTC
golang-github-yosssi-ace-0.0.5-3.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0c91eb16d1

Comment 18 Fedora Update System 2017-04-06 13:43:49 UTC
golang-github-yosssi-ace-0.0.5-3.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.